// totally unclean experimental colection of bytes...

uniform float ScaleX;
uniform float ScaleY;
uniform float ScaleZ;

attribute float aWater;

varying vec3 vNormal;
varying vec3 vLight;
varying vec3 vHalfVec;
varying vec4 vDiffuse, vAmbient;
varying vec3 vPos;

varying float vFogFactor;

varying vec4 vTexCoordShadow;

void main(void)
{
  // souradnice noise textury
  vPos = gl_Vertex.xyz;
  vTexCoordShadow=gl_TextureMatrix[3]*gl_Vertex;
                              
  // vypocet promennych vyuzivanych pro osvetleni ve fragment shaderu
  vec3 Pos = normalize(gl_ModelViewMatrix * gl_Vertex).xyz;
	vLight = normalize(gl_LightSource[0].position).xyz;
  vHalfVec = normalize(gl_LightSource[0].halfVector.xyz);
  vHalfVec = normalize(vHalfVec-normalize(Pos-vLight)*8.0);
  vNormal = normalize(gl_Normal);

  // barva terenu
  vec4 TerrainTypeColor;
  vec4 snow=vec4(1.2,1.2,1.3,1.0);
  vec4 rock=vec4(0.6,0.6,0.7,1.0);
  vec4 grass=mix(vec4(0.8,0.7,0.3,1.0),vec4(0.5,0.6,0.2,1.0),clamp(vPos.z*0.1+0.5,0.0,1.0));
  vec4 mud=vec4(0.7,0.6,0.3,1.0);

  // XXX chce to doresit: voda na snehu -> snih / skala; voda na sikme skale -> skala
  float f_rock=clamp(clamp(vPos.z*0.1-1.2,-0.2,1.0)+(1.0-vNormal.z)*2.0,0.0,1.0);
  float f_snow=clamp(vPos.z*0.2-5.0+vNormal.z*1.5,0.0,1.0);
  float f_mud=clamp(aWater*10.0,0.0,1.0);
  //float f_mud=clamp(clamp(aWater*10.0,0.0,1.0)-f_snow,0.0,1.0);

  f_snow=clamp(f_snow-f_mud,0.0,1.0);
  f_rock=clamp(f_rock-(f_snow+f_mud),0.0,1.0);
  float f_grass=clamp(1.0-(f_rock+f_snow+f_mud),0.0,1.0);

  TerrainTypeColor=snow*f_snow + rock*f_rock + grass*f_grass + mud*f_mud;

  // vypocet barev podle vlastnosti materialu a svetla - zatim se nepocita konkretni osvetleni, jen barvy!
  vDiffuse = TerrainTypeColor * gl_LightSource[0].diffuse;
  vAmbient = TerrainTypeColor * 0.5 * (gl_LightSource[0].ambient + gl_LightModel.ambient);

  // mlha
  vFogFactor=sin(clamp(aWater/2.0,0.0,1.57079632679485));

  gl_Position = ftransform();		
}
